<template>
    <div>

        <div v-if="!rows">
            <div class="d-flex justify-content-center">
                <div class="text-center text-success my-2">
                    <b-spinner class="align-middle"></b-spinner>
                    <strong class="mx-2" >Carregando...</strong>
                </div>
            </div>
        </div>

        <div v-else>

            <b-pagination v-model="currentPage" pills align="center" :per-page="perPage" :total-rows="rows"></b-pagination>

            <p class="mt-3">Total de Usuários : {{rows}} | Pagina: {{ currentPage }}</p>

            <b-table class="table" striped hover small :fields="fields" :per-page="perPage" :current-page="currentPage" :items="items" responsive="sm" >
                    <template #cell(type)="data">
                        <span v-if="data.value == 1" ><b-badge variant="danger">ADM</b-badge> </span> 
                        <span v-if="data.value == 2" ><b-badge variant="success">USER</b-badge> </span>
                    </template>
                    <template #cell(id)="data">
                        <b-badge @click="addServico(data.value)" variant="primary">ADD Serviço</b-badge>
                    </template>
            </b-table>

            <div>

                <b-modal id="modalServico" title="Serviço" hide-footer>
                    <p>Deseja mesmo Adcionar um novo Serviço para <strong>{{userServico.name}}</strong></p>
                    <label for="et">Etiqueta do Serviço</label>
                    <input id="et" type="text" v-model="etiqueta" class="form-control mb-3">
                    <button class="btn btn-success" @click="sendServico"> SIM </button>
                    <button class="btn btn-danger" @click="hideModal"> NÃO </button>
                </b-modal>

                <b-modal id="modalStatus" :header-bg-variant="alert.bg" centered  :header-text-variant="alert.color" header-class='border-0 ' body-class='d-none' :title="alert.msg" hide-body  hide-footer>
                </b-modal>
            </div>

        </div>

    </div>
</template>

<script>
import axios from 'axios'
export default {
  name: 'Login',
  data(){
    return{
        perPage: 10,
        currentPage: 1,
        items: [],
        fields: [
          { key: 'name', label: 'Nome' },
          { key: 'email', label: 'Email' },
          { key: 'phone', label: 'Tel' },
          { key: 'type', label: 'Tipo' },
          { key: 'id', label: 'Serviço' },
        ],

        ////////////////////////
        
        userServico:{},

        etiqueta: null,

        alert: {
            bg: 'success',
            color: 'white',
            msg: 'Sucesso ao Cadastrar',
        }
    }
  },
  computed: {
    rows() {
        return this.items.length
    }
  },
  methods:{
    getUser(){
      const _vn = this

      axios.get('https://7re2usa707.execute-api.us-east-1.amazonaws.com/production/user')
      .then(function (response) {
        // console.log(response.data)
        _vn.items = response.data
      })
      .catch(function (error) {
        console.log(error);
      });
    },
    addServico(id_user){
      this.items.map(item => {
            item.id == id_user ? this.userServico = item : null
        })
      this.$bvModal.show("modalServico")

    },
    sendServico(){
        const _vn = this
        if( _vn.userServico.id){
            axios.post('https://7re2usa707.execute-api.us-east-1.amazonaws.com/production/servico', {
                "idUser": _vn.userServico.id,
                "etiqueta": _vn.etiqueta,
                "envio": "false",
                "codRastreio": "null",
                "dataInstalacao": "null",
                "iniInstalacao": "null",
                "conclusao": "null"
            })
            .then(function (response) {
                console.log(response)
                if(response.data.code == 200){
                     _vn.hideModal()
                    _vn.$bvModal.show("modalStatus")
                    _vn.alert = {
                        bg: 'success',
                        color: 'white',
                        msg: 'Serviço cadastrado com sucesso :)',
                    }
                } else {
                    _vn.hideModal()
                      _vn.$bvModal.show("modalStatus")
                    _vn.alert = {
                        bg: 'danger',
                        color: 'white',
                        msg: 'Erro ao salvar. tente mais tarde :/',
                    }

                }
            })
            .catch(function (error) {
                console.log(error);
            });
            
        } else {
            _vn.hideModal()
            _vn.$bvModal.show("modalStatus")
            _vn.alert = {
                bg: 'danger',
                color: 'white',
                msg: 'Erro ao salvar. tente mais tarde :/',
            }

        }
       
    },
    hideModal(){
        this.$bvModal.hide("modalServico")
    }
  },
  mounted(){
    this.getUser()
  }
  
}
</script>

<style>
@media(max-width: 767px){
    table.table th, table.table td  {
         font-size: 12px;
    }
}
</style>